searchNodes=[{"doc":"RFC 4180 compliant CSV parsing and encoding for Elixir. Allows to specify other separators, so it could also be named: TSV, but it isn't.","ref":"CSV.html","title":"CSV","type":"module"},{"doc":"Decode a stream of comma-separated lines into a stream of tuples. Decoding errors will be inlined into the stream. Options These are the options: :separator – The separator token to use, defaults to ?, . Must be a codepoint (syntax: ? + (your separator)). :escape_character – The escape character token to use, defaults to ?&quot; . Must be a codepoint (syntax: ? + (your escape character)). :escape_max_lines – The number of lines an escape sequence is allowed to span, defaults to 10. :field_transform – A function with arity 1 that will get called with each field and can apply transformations. Defaults to identity function. This function will get called for every field and therefore should return quickly. :headers – When set to true , will take the first row of the csv and use it as header values. When set to a list, will use the given list as header values. When set to false (default), will use no header values. When set to anything but false , the resulting rows in the matrix will be maps instead of lists. :validate_row_length – When set to true , will take the first row of the csv or its headers and validate that following rows are of the same length. Defaults to false . :unescape_formulas – When set to true , will remove formula escaping inserted to prevent CSV Injection . Examples Convert a filestream into a stream of rows in order of the given stream: iex&gt; &quot;../test/fixtures/docs/valid.csv&quot; iex&gt; |&gt; Path . expand ( __DIR__ ) iex&gt; |&gt; File . stream! iex&gt; |&gt; CSV . decode iex&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ] , ok : [ &quot;d&quot; , &quot;e&quot; , &quot;f&quot; ] ] Read from a file with a Byte Order Mark (BOM): iex&gt; &quot;../test/fixtures/utf8-with-bom.csv&quot; ...&gt; |&gt; Path . expand ( __DIR__ ) ...&gt; |&gt; File . stream! ( [ :trim_bom ] ) ...&gt; |&gt; CSV . decode ( ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; ] , ok : [ &quot;d&quot; , &quot;e&quot; ] ] Read from an UTF-16 encoded file with a Byte Order Mark (BOM): iex&gt; &quot;../test/fixtures/utf16-little-with-bom.csv&quot; ...&gt; |&gt; Path . expand ( __DIR__ ) ...&gt; |&gt; File . stream! ( [ :trim_bom , encoding : { :utf16 , :little } ] ) ...&gt; |&gt; CSV . decode ( ) ...&gt; |&gt; Enum . take ( 3 ) [ ok : [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ] , ok : [ &quot;1&quot; , &quot;2&quot; , &quot;3&quot; ] , ok : [ &quot;4&quot; , &quot;5&quot; , &quot;ʤ&quot; ] ] Read from an UTF-16 big endian encoded file with a Byte Order Mark (BOM): iex&gt; &quot;../test/fixtures/utf16-big-with-bom.csv&quot; ...&gt; |&gt; Path . expand ( __DIR__ ) ...&gt; |&gt; File . stream! ( [ :trim_bom , encoding : { :utf16 , :big } ] ) ...&gt; |&gt; CSV . decode ( ) ...&gt; |&gt; Enum . take ( 3 ) [ ok : [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ] , ok : [ &quot;1&quot; , &quot;2&quot; , &quot;3&quot; ] , ok : [ &quot;4&quot; , &quot;5&quot; , &quot;ʤ&quot; ] ] Errors will show up as error tuples: iex&gt; &quot;../test/fixtures/docs/escape-errors.csv&quot; iex&gt; |&gt; Path . expand ( __DIR__ ) iex&gt; |&gt; File . stream! iex&gt; |&gt; CSV . decode iex&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ] , error : &quot;Escape sequence started on line 2: \\n \\n \\&quot; d,e,f \\n \\n did not terminate before the stream halted. Parsing will continue on line 3. \\n &quot; ] Map an existing stream of lines separated by a token to a stream of rows with a header row: iex&gt; [ &quot;a;b \\n &quot; , &quot;c;d \\n &quot; , &quot;e;f \\n &quot; ] iex&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) iex&gt; |&gt; CSV . decode ( separator : ?; , headers : true ) iex&gt; |&gt; Enum . take ( 2 ) [ ok : %{ &quot;a&quot; =&gt; &quot;c&quot; , &quot;b&quot; =&gt; &quot;d&quot; } , ok : %{ &quot;a&quot; =&gt; &quot;e&quot; , &quot;b&quot; =&gt; &quot;f&quot; } ] Map a stream with custom escape characters: iex&gt; [ &quot;@a@,@b@ \\n &quot; , &quot;@c@,@d@ \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV . decode ( escape_character : ?@ ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; ] , ok : [ &quot;c&quot; , &quot;d&quot; ] ] Map a stream with custom separator characters: iex&gt; [ &quot;a;b \\n &quot; , &quot;c;d \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV . decode ( separator : ?; ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; ] , ok : [ &quot;c&quot; , &quot;d&quot; ] ] Trim each field: iex&gt; [ &quot; a , b \\n &quot; , &quot; c , d \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV . decode ( field_transform : &amp; String . trim / 1 ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; ] , ok : [ &quot;c&quot; , &quot;d&quot; ] ] Map an existing stream of lines separated by a token to a stream of rows with a given header row: iex&gt; [ &quot;a;b \\n &quot; , &quot;c;d \\n &quot; , &quot;e;f \\n &quot; ] iex&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) iex&gt; |&gt; CSV . decode ( separator : ?; , headers : [ :x , :y ] ) iex&gt; |&gt; Enum . take ( 2 ) [ ok : %{ :x =&gt; &quot;a&quot; , :y =&gt; &quot;b&quot; } , ok : %{ :x =&gt; &quot;c&quot; , :y =&gt; &quot;d&quot; } ]","ref":"CSV.html#decode/2","title":"CSV.decode/2","type":"function"},{"doc":"Decode a stream of comma-separated lines into a stream of tuples. Errors when decoding will get raised immediately. Options These are the options: :separator – The separator token to use, defaults to ?, . Must be a codepoint (syntax: ? + (your separator)). :escape_character – The escape character token to use, defaults to ?&quot; . Must be a codepoint (syntax: ? + (your escape character)). :field_transform – A function with arity 1 that will get called with each field and can apply transformations. Defaults to identity function. This function will get called for every field and therefore should return quickly. :headers – When set to true , will take the first row of the csv and use it as header values. When set to a list, will use the given list as header values. When set to false (default), will use no header values. When set to anything but false , the resulting rows in the matrix will be maps instead of lists. :validate_row_length – When set to true , will take the first row of the csv or its headers and validate that following rows are of the same length. Will raise an error if validation fails. Defaults to false . :unescape_formulas – When set to true , will remove formula escaping inserted to prevent CSV Injection . :unredact_exceptions – When set to true , will show csv data in message output of exceptions thrown. Only use this when using CSV strict mode in environments and situations where there is no concern with exception message data leaking in logs. Defaults to false . Examples Convert a filestream into a stream of rows in order of the given stream: iex&gt; &quot;../test/fixtures/docs/valid.csv&quot; iex&gt; |&gt; Path . expand ( __DIR__ ) iex&gt; |&gt; File . stream! ( ) iex&gt; |&gt; CSV . decode! ( ) iex&gt; |&gt; Enum . take ( 2 ) [ [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ] , [ &quot;d&quot; , &quot;e&quot; , &quot;f&quot; ] ] Read from a file with a Byte Order Mark (BOM): iex&gt; &quot;../test/fixtures/utf8-with-bom.csv&quot; ...&gt; |&gt; Path . expand ( __DIR__ ) ...&gt; |&gt; File . stream! ( [ :trim_bom ] ) ...&gt; |&gt; CSV . decode! ( ) ...&gt; |&gt; Enum . take ( 2 ) [ [ &quot;a&quot; , &quot;b&quot; ] , [ &quot;d&quot; , &quot;e&quot; ] ] Read from an UTF-16 encoded file with a Byte Order Mark (BOM): iex&gt; &quot;../test/fixtures/utf16-little-with-bom.csv&quot; ...&gt; |&gt; Path . expand ( __DIR__ ) ...&gt; |&gt; File . stream! ( [ :trim_bom , encoding : { :utf16 , :little } ] ) ...&gt; |&gt; CSV . decode! ( ) ...&gt; |&gt; Enum . take ( 3 ) [ [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ] , [ &quot;1&quot; , &quot;2&quot; , &quot;3&quot; ] , [ &quot;4&quot; , &quot;5&quot; , &quot;ʤ&quot; ] ] Read from an UTF-16 big endian encoded file with a Byte Order Mark (BOM): iex&gt; &quot;../test/fixtures/utf16-big-with-bom.csv&quot; ...&gt; |&gt; Path . expand ( __DIR__ ) ...&gt; |&gt; File . stream! ( [ :trim_bom , encoding : { :utf16 , :big } ] ) ...&gt; |&gt; CSV . decode! ( ) ...&gt; |&gt; Enum . take ( 3 ) [ [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ] , [ &quot;1&quot; , &quot;2&quot; , &quot;3&quot; ] , [ &quot;4&quot; , &quot;5&quot; , &quot;ʤ&quot; ] ] Map an existing stream of lines separated by a token to a stream of rows with a header row: iex&gt; [ &quot;a;b \\n &quot; , &quot;c;d \\n &quot; , &quot;e;f&quot; ] iex&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) iex&gt; |&gt; CSV . decode! ( separator : ?; , headers : true ) iex&gt; |&gt; Enum . take ( 2 ) [ %{ &quot;a&quot; =&gt; &quot;c&quot; , &quot;b&quot; =&gt; &quot;d&quot; } , %{ &quot;a&quot; =&gt; &quot;e&quot; , &quot;b&quot; =&gt; &quot;f&quot; } ] Map a stream with custom escape characters: iex&gt; [ &quot;@a@,@b@ \\n &quot; , &quot;@c@,@d@ \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV . decode! ( escape_character : ?@ ) ...&gt; |&gt; Enum . take ( 2 ) [ [ &quot;a&quot; , &quot;b&quot; ] , [ &quot;c&quot; , &quot;d&quot; ] ] Map an existing stream of lines separated by a token to a stream of rows with a given header row: iex&gt; [ &quot;a;b \\n &quot; , &quot;c;d \\n &quot; , &quot;e;f&quot; ] iex&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) iex&gt; |&gt; CSV . decode! ( separator : ?; , headers : [ :x , :y ] ) iex&gt; |&gt; Enum . take ( 2 ) [ %{ :x =&gt; &quot;a&quot; , :y =&gt; &quot;b&quot; } , %{ :x =&gt; &quot;c&quot; , :y =&gt; &quot;d&quot; } ] Trim each field: iex&gt; [ &quot; a , b \\n &quot; , &quot; c , d \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV . decode! ( field_transform : &amp; String . trim / 1 ) ...&gt; |&gt; Enum . take ( 2 ) [ [ &quot;a&quot; , &quot;b&quot; ] , [ &quot;c&quot; , &quot;d&quot; ] ] Replace invalid codepoints: iex&gt; &quot;../test/fixtures/broken-encoding.csv&quot; ...&gt; |&gt; Path . expand ( __DIR__ ) ...&gt; |&gt; File . stream! ( ) ...&gt; |&gt; CSV . decode! ( field_transform : fn field -&gt; ...&gt; if String . valid? ( field ) do ...&gt; field ...&gt; else ...&gt; field ...&gt; |&gt; String . codepoints ( ) ...&gt; |&gt; Enum . map ( fn codepoint -&gt; if String . valid? ( codepoint ) , do : codepoint , else : &quot;?&quot; end ) ...&gt; |&gt; Enum . join ( ) ...&gt; end ...&gt; end ) ...&gt; |&gt; Enum . take ( 2 ) [ [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; , &quot;?_?&quot; ] , [ &quot;ಠ_ಠ&quot; ] ]","ref":"CSV.html#decode!/2","title":"CSV.decode!/2","type":"function"},{"doc":"Encode a table stream into a stream of RFC 4180 compliant CSV lines for writing to a file or other IO. Options These are the options: :separator – The separator token to use, defaults to ?, . Must be a codepoint (syntax: ? + (your separator)). :escape_character – The escape character token to use, defaults to ?&quot; . Must be a codepoint (syntax: ? + (your escape character)). :delimiter – The delimiter token to use, defaults to \\r\\n . Must be a string. :force_escaping – When set to true , will escape fields even if they do not contain characters that require escaping :escape_formulas – When set to true , will escape formulas to prevent CSV Injection . :headers When set to false (default), will use the raw inputs as elements. When set to anything but false , all elements in the input stream are assumed to be maps. When set to true , uses the keys of the first map as the first element in the stream. All subsequent elements are the values of the maps. When set to a list, will use the given list as the first element in the stream and order all subsequent elements using that list. When set to a keyword list, will use the keys of the keyword list to match the keys of the data, and the values of the keyword list to be the values in the first row of the output. Examples Convert a stream of rows with fields into a stream of lines: iex&gt; [ ~w(a b) , ~w(c d) ] iex&gt; |&gt; CSV . encode iex&gt; |&gt; Enum . take ( 2 ) [ &quot;a,b \\r \\n &quot; , &quot;c,d \\r \\n &quot; ] Convert a stream of rows with fields with escape sequences into a stream of lines: iex&gt; [ [ &quot;a \\n b&quot; , &quot; \\t c&quot; ] , [ &quot;de&quot; , &quot; \\t f \\&quot; &quot; ] ] iex&gt; |&gt; CSV . encode ( separator : ?\\t , delimiter : &quot; \\n &quot; ) iex&gt; |&gt; Enum . take ( 2 ) [ &quot; \\&quot; a \\n b \\&quot; \\t \\&quot; \\t c \\&quot; \\n &quot; , &quot;de \\t \\&quot; \\t f \\&quot; \\&quot; \\&quot; \\n &quot; ] Convert a stream of rows with fields into a stream of lines forcing escaping with a custom character: iex&gt; [ ~w(a b) , ~w(c d) ] iex&gt; |&gt; CSV . encode ( force_escaping : true , escape_character : ?@ ) iex&gt; |&gt; Enum . take ( 2 ) [ &quot;@a@,@b@ \\r \\n &quot; , &quot;@c@,@d@ \\r \\n &quot; ] Convert a stream of rows with fields with formulas into a stream of lines: iex&gt; [ ~w(@a =b) , ~w(-c +d) ] iex&gt; |&gt; CSV . encode ( escape_formulas : true ) iex&gt; |&gt; Enum . take ( 2 ) [ &quot; \\&quot; &#39;@a \\&quot; , \\&quot; &#39;=b \\&quot; \\r \\n &quot; , &quot; \\&quot; &#39;-c \\&quot; , \\&quot; &#39;+d \\&quot; \\r \\n &quot; ] Convert a stream of row maps iex&gt; [ %{ header1 : &quot;header1 value1&quot; , header2 : &quot;header2 value1&quot; } ] ...&gt; |&gt; CSV . encode ( headers : true ) ...&gt; |&gt; Enum . to_list ( ) [ &quot;header1,header2 \\r \\n &quot; , &quot;header1 value1,header2 value1 \\r \\n &quot; ] Convert a stream of rows renaming the headers by passing in a keyword list iex&gt; [ %{ a : &quot;value!&quot; } ] ...&gt; |&gt; CSV . encode ( headers : [ a : &quot;x&quot; , b : &quot;y&quot; ] ) ...&gt; |&gt; Enum . to_list ( ) [ &quot;x,y \\r \\n &quot; , &quot;value!, \\r \\n &quot; ]","ref":"CSV.html#encode/2","title":"CSV.encode/2","type":"function"},{"doc":"","ref":"CSV.html#t:decode_options/0","title":"CSV.decode_options/0","type":"type"},{"doc":"","ref":"CSV.html#t:encode_options/0","title":"CSV.encode_options/0","type":"type"},{"doc":"The Decoder CSV module sends lines of delimited values from a stream to the parser and converts rows coming from the CSV parser module to a consumable stream.","ref":"CSV.Decoding.Decoder.html","title":"CSV.Decoding.Decoder","type":"module"},{"doc":"Decode a stream of comma-separated lines into a stream of rows that are either lists of fields or maps of headers to fields. The Decoder expects line or variable size byte stream input. Options These are the options: :separator – The separator token to use, defaults to ?, . Must be a codepoint (syntax: ? + (your separator)). :escape_character – The escape character token to use, defaults to ?&quot; . Must be a codepoint (syntax: ? + (your escape character)). :escape_max_lines – The number of lines an escape sequence is allowed to span, defaults to 10. :field_transform – A function with arity 1 that will get called with each field and can apply transformations. Defaults to identity function. This function will get called for every field and therefore should return quickly. :headers – When set to true , will take the first row of the csv and use it as header values. When set to a list, will use the given list as header values. When set to false (default), will use no header values. When set to anything but false , the resulting rows in the matrix will be maps instead of lists. :validate_row_length – When set to true , will take the first row of the csv or its headers and validate that following rows are of the same length. Defaults to false . :escape_formulas – When set to true , will remove formula escaping inserted to prevent CSV Injection . Examples Convert a stream with inlined escape sequences into a stream of rows: iex&gt; [ &quot;a,b \\n &quot; , &quot;c,d \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV.Decoding.Decoder . decode ...&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; ] , ok : [ &quot;c&quot; , &quot;d&quot; ] ] Convert a stream with custom escape characters into a stream of rows: iex&gt; [ &quot;@a@,@b@ \\n &quot; , &quot;@c@,@d@ \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV.Decoding.Decoder . decode ( escape_character : ?@ ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; ] , ok : [ &quot;c&quot; , &quot;d&quot; ] ] Convert a line stream with escape sequences into a stream of rows: iex&gt; [ &quot;&#39;@a,&#39;=b \\n &quot; , &quot;&#39;-c,&#39;+d \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV.Decoding.Decoder . decode ( unescape_formulas : true ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;@a&quot; , &quot;=b&quot; ] , ok : [ &quot;-c&quot; , &quot;+d&quot; ] ] Trim each field: iex&gt; [ &quot; a , b \\n &quot; , &quot; c , d \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV.Decoding.Decoder . decode ( field_transform : &amp; String . trim / 1 ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; ] , ok : [ &quot;c&quot; , &quot;d&quot; ] ] Read from a file with a Byte Order Mark (BOM): iex&gt; &quot;../../../test/fixtures/utf8-with-bom.csv&quot; ...&gt; |&gt; Path . expand ( __DIR__ ) ...&gt; |&gt; File . stream! ( [ :trim_bom ] ) ...&gt; |&gt; CSV.Decoding.Decoder . decode ( ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; ] , ok : [ &quot;d&quot; , &quot;e&quot; ] ] Replace invalid codepoints: iex&gt; &quot;../../../test/fixtures/broken-encoding.csv&quot; ...&gt; |&gt; Path . expand ( __DIR__ ) ...&gt; |&gt; File . stream! ( ) ...&gt; |&gt; CSV.Decoding.Decoder . decode ( field_transform : fn field -&gt; ...&gt; if String . valid? ( field ) do ...&gt; field ...&gt; else ...&gt; field ...&gt; |&gt; String . codepoints ( ) ...&gt; |&gt; Enum . map ( fn codepoint -&gt; if String . valid? ( codepoint ) , do : codepoint , else : &quot;?&quot; end ) ...&gt; |&gt; Enum . join ( ) ...&gt; end ...&gt; end ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; , &quot;?_?&quot; ] , ok : [ &quot;ಠ_ಠ&quot; ] ] Map an existing stream of lines separated by a token to a stream of rows with a header row: iex&gt; [ &quot;a;b \\n &quot; , &quot;c;d \\n &quot; , &quot;e;f \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV.Decoding.Decoder . decode ( separator : ?; , headers : true ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : %{ &quot;a&quot; =&gt; &quot;c&quot; , &quot;b&quot; =&gt; &quot;d&quot; } , ok : %{ &quot;a&quot; =&gt; &quot;e&quot; , &quot;b&quot; =&gt; &quot;f&quot; } ] Map an existing stream of lines separated by a token to a stream of rows with a header row with duplications: iex&gt; [ &quot;a;b;b \\n &quot; , &quot;c;d;e \\n &quot; , &quot;f;g;h \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV.Decoding.Decoder . decode ( separator : ?; , headers : true ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : %{ &quot;a&quot; =&gt; &quot;c&quot; , &quot;b&quot; =&gt; [ &quot;d&quot; , &quot;e&quot; ] } , ok : %{ &quot;a&quot; =&gt; &quot;f&quot; , &quot;b&quot; =&gt; [ &quot;g&quot; , &quot;h&quot; ] } ] Map an existing stream of lines separated by a token to a stream of rows with a given header row: iex&gt; [ &quot;a;b \\n &quot; , &quot;c;d \\n &quot; , &quot;e;f \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV.Decoding.Decoder . decode ( separator : ?; , headers : [ :x , :y ] ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : %{ :x =&gt; &quot;a&quot; , :y =&gt; &quot;b&quot; } , ok : %{ :x =&gt; &quot;c&quot; , :y =&gt; &quot;d&quot; } ] Decode a CSV string: iex&gt; [ &quot;id,name \\r \\n 1,Jane \\r \\n 2,George \\r \\n 3,John&quot; ] ...&gt; |&gt; CSV.Decoding.Decoder . decode ( headers : true ) ...&gt; |&gt; Enum . map ( &amp; ( &amp;1 ) ) [ ok : %{ &quot;id&quot; =&gt; &quot;1&quot; , &quot;name&quot; =&gt; &quot;Jane&quot; } , ok : %{ &quot;id&quot; =&gt; &quot;2&quot; , &quot;name&quot; =&gt; &quot;George&quot; } , ok : %{ &quot;id&quot; =&gt; &quot;3&quot; , &quot;name&quot; =&gt; &quot;John&quot; } ]","ref":"CSV.Decoding.Decoder.html#decode/2","title":"CSV.Decoding.Decoder.decode/2","type":"function"},{"doc":"","ref":"CSV.Decoding.Decoder.html#t:decode_options/0","title":"CSV.Decoding.Decoder.decode_options/0","type":"type"},{"doc":"The Parser CSV module transforms a stream of byte chunks or bytes into a stream of row tuples and (potentially) error tuples. It follows the grammar defined in RFC4180 .","ref":"CSV.Decoding.Parser.html","title":"CSV.Decoding.Parser","type":"module"},{"doc":"","ref":"CSV.Decoding.Parser.html#add_error/3","title":"CSV.Decoding.Parser.add_error/3","type":"function"},{"doc":"","ref":"CSV.Decoding.Parser.html#add_row/2","title":"CSV.Decoding.Parser.add_row/2","type":"function"},{"doc":"Parse a stream of comma-separated lines into a stream of rows. The Parser expects line or variable size byte stream input. Options These are the options: :separator – The separator token to use, defaults to ?, . Must be a codepoint (syntax: ? + (your separator)). :field_transform – A function with arity 1 that will get called with each field and can apply transformations. Defaults to identity function. This function will get called for every field and therefore should return quickly. :unescape_formulas – When set to true , will remove formula escaping inserted to prevent CSV Injection . Examples Convert a stream of lines with inlined escape sequences into a stream of rows: iex&gt; [ &quot;a,b \\n &quot; , &quot;c,d \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV.Decoding.Parser . parse ...&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; ] , ok : [ &quot;c&quot; , &quot;d&quot; ] ] Convert a stream of lines with into a stream of rows trimming each field: iex&gt; [ &quot; a , b \\n &quot; , &quot; c , d \\n &quot; ] ...&gt; |&gt; Stream . map ( &amp; ( &amp;1 ) ) ...&gt; |&gt; CSV.Decoding.Parser . parse ( field_transform : &amp; String . trim / 1 ) ...&gt; |&gt; Enum . take ( 2 ) [ ok : [ &quot;a&quot; , &quot;b&quot; ] , ok : [ &quot;c&quot; , &quot;d&quot; ] ]","ref":"CSV.Decoding.Parser.html#parse/2","title":"CSV.Decoding.Parser.parse/2","type":"function"},{"doc":"","ref":"CSV.Decoding.Parser.html#t:parse_options/0","title":"CSV.Decoding.Parser.parse_options/0","type":"type"},{"doc":"The module defaults of CSV.","ref":"CSV.Defaults.html","title":"CSV.Defaults","type":"module"},{"doc":"Implement encoding for your data types.","ref":"CSV.Encode.html","title":"CSV.Encode","type":"protocol"},{"doc":"The encode function to implement, gets passed the data and env as a keyword list containing the currently used separator and delimiter.","ref":"CSV.Encode.html#encode/2","title":"CSV.Encode.encode/2","type":"function"},{"doc":"All the types that implement this protocol.","ref":"CSV.Encode.html#t:t/0","title":"CSV.Encode.t/0","type":"type"},{"doc":"The Encoder CSV module takes a table stream and transforms it into RFC 4180 compliant stream of lines for writing to a CSV File or other IO.","ref":"CSV.Encoding.Encoder.html","title":"CSV.Encoding.Encoder","type":"module"},{"doc":"Encode a table stream into a stream of RFC 4180 compliant CSV lines for writing to a file or other IO. Options These are the options: :separator – The separator character to use, defaults to ?, . Must be a codepoint (syntax: ? + your separator). :escape_character – The escape character to use, defaults to ?&quot; . Must be a codepoint (syntax: ? + your escape character). :delimiter – The delimiter token to use, defaults to &quot;\\r\\n&quot; . :headers When set to false (default), will use the raw inputs as elements. When set to anything but false , all elements in the input stream are assumed to be maps. When set to true , uses the keys of the first map as the first element in the stream. All subsequent elements are the values of the maps. When set to a list, will use the given list as the first element in the stream and order all subsequent elements using that list. When set to a keyword list, will use the keys of the keyword list to match the keys of the data, and the values of the keyword list to be the values in the first row of the output. :escape_formulas – Escape formulas to prevent CSV Injection . Examples Convert a stream of rows with cells into a stream of lines: iex&gt; [ ~w(a b) , ~w(c d) ] iex&gt; |&gt; CSV.Encoding.Encoder . encode iex&gt; |&gt; Enum . take ( 2 ) [ &quot;a,b \\r \\n &quot; , &quot;c,d \\r \\n &quot; ] Convert a stream of maps into a stream of lines: iex&gt; [ %{ &quot;a&quot; =&gt; 1 , &quot;b&quot; =&gt; 2 } , %{ &quot;a&quot; =&gt; 3 , &quot;b&quot; =&gt; 4 } ] iex&gt; |&gt; CSV.Encoding.Encoder . encode ( headers : true ) iex&gt; |&gt; Enum . to_list ( ) [ &quot;a,b \\r \\n &quot; , &quot;1,2 \\r \\n &quot; , &quot;3,4 \\r \\n &quot; ] Convert a stream of rows with cells with escape sequences into a stream of lines: iex&gt; [ [ &quot;a \\n b&quot; , &quot; \\t c&quot; ] , [ &quot;de&quot; , &quot; \\t f \\&quot; &quot; ] ] iex&gt; |&gt; CSV.Encoding.Encoder . encode ( separator : ?\\t , delimiter : &quot; \\n &quot; ) iex&gt; |&gt; Enum . take ( 2 ) [ &quot; \\&quot; a \\n b \\&quot; \\t \\&quot; \\t c \\&quot; \\n &quot; , &quot;de \\t \\&quot; \\t f \\&quot; \\&quot; \\&quot; \\n &quot; ]","ref":"CSV.Encoding.Encoder.html#encode/2","title":"CSV.Encoding.Encoder.encode/2","type":"function"},{"doc":"Raised at runtime when the CSV stream either ends with unfinished escape sequences or escape sequences span more lines than specified by escape_max_lines (default 1000).","ref":"CSV.EscapeSequenceError.html","title":"CSV.EscapeSequenceError","type":"exception"},{"doc":"Raised at runtime when the CSV has rows of variable length and validate_row_length is set to true.","ref":"CSV.RowLengthError.html","title":"CSV.RowLengthError","type":"exception"},{"doc":"Raised at runtime when the CSV row has stray quotes.","ref":"CSV.StrayEscapeCharacterError.html","title":"CSV.StrayEscapeCharacterError","type":"exception"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Strict mode: Exception messages of thrown exceptions are now redacted by default to avoid data unintentionally leaking into logs. This behaviour change is not considered to be breaking backwards compatibility since source data presented in exeption messages is not considered part of the CSV public API. Option to (un)redact exception messages [contributed in #122 by @taylor-redden-papa","ref":"changelog.html#3-1-0-2023-09-24","title":"Changelog - 3.1.0 (2023-09-24)","type":"extras"},{"doc":"Exclude dialyzer files from library package [contributed in #121 by @milmazz","ref":"changelog.html#3-0-5-2022-12-03","title":"Changelog - 3.0.5 (2022-12-03)","type":"extras"},{"doc":"Add missing escape_max_lines to decode options typespec closes #120","ref":"changelog.html#3-0-4-2022-11-19","title":"Changelog - 3.0.4 (2022-11-19)","type":"extras"},{"doc":"Ensure that reparsing of lines with stray escape characters does not produce duplicate error output closes #119 Deduplication of type specs in #118 contributed by @joseph-lozano Documentation fixes and improvements contributed by @jamesvl in #115","ref":"changelog.html#3-0-3-2022-11-04","title":"Changelog - 3.0.3 (2022-11-04)","type":"extras"},{"doc":"Ensure that escaped fields as the last field on the last line without a newline are included in the results - fixes #117 raised by @superhawk610","ref":"changelog.html#3-0-2-2022-11-03","title":"Changelog - 3.0.2 (2022-11-03)","type":"extras"},{"doc":"Ensure that stray escape quotes and unterminated escape sequences on a last line without a newline produce errors","ref":"changelog.html#3-0-1-2022-10-25","title":"Changelog - 3.0.1 (2022-10-25)","type":"extras"},{"doc":"The parallel parser/lexer with a binary matching parser with better performance. A new :field_transform option allows specifying functionality applied when decoding any field through a function Escape characters can now be specified using the :escape_character option, this Closes #59 The library will now reparse lines that follow e.g. an unterminated escape sequence. This ensures that all possible valid rows will be returned in normal mode Encoding checks have been removed because they can either be done using :field_transform or outside the library Better docs Upgrading from 2.x Parallelism has been removed , alongside its options :num_workers and :worker_work_ratio . You can safely remove them. StrayQuoteError is now StrayEscapeCharacterError . If you catch this error in your code, you need to rename it. The :strip_fields option needs to be replaced with the :field_transform option: File . stream! ( &quot;data.csv&quot; ) |&gt; CSV . decode ( field_transform : &amp; String . trim / 1 ) :validate_row_length now defaults to false . This option produces an error for rows with different length. Set it to true to get the same behaviour as in 2.x :escape_formulas is now :unescape_formulas for decode and decode! . It is still :escape_formulas for encode . Change :escape_formulas to :unescape_formulas in decode calls to get the same behaviour as in 2.x :escape_max_lines now defaults to 10 instead of 1000 . To get the same behaviour as in 2.x, use: File . stream! ( &quot;data.csv&quot; ) |&gt; CSV . decode ( escape_max_lines : 1000 ) :replace has been removed . CSV will now return fields with incorrect encoding as-is. You can use the new :field_transform option to provide a function transforming fields while they are being parsed. This allows to e.g. replace incorrect encoding: defp replace_bad_encoding ( field ) do if String . valid? ( field ) do field else field |&gt; String . codepoints ( ) |&gt; Enum . map ( fn codepoint -&gt; if String . valid? ( codepoint ) , do : codepoint , else : &quot;?&quot; end ) |&gt; Enum . join ( ) end end","ref":"changelog.html#3-0-0-2022-10-25","title":"Changelog - 3.0.0 (2022-10-25)","type":"extras"},{"doc":"Optional parameter escape_formulas to prevent CSV injection. Fixes #103 reported by @maennchen . Contributed by @maennchen in PR #104 . Optional parameter force_quotes to force quotes when encoding contributed by @stuart Bugfix to pass non UTF-8 lines through in normal mode so other lines can be processed, Fixes #107 . Contributed by @al2o3cr . Allow to encode keyword lists specifying headers as values, contributed by @michaelchu Better docs thanks to @kianmeng","ref":"changelog.html#2-5-0-2022-09-17","title":"Changelog - 2.5.0 (2022-09-17)","type":"extras"},{"doc":"Fix unnecessary escaping of delimiters when encoding Fixes #70 reported by @karmajunkie","ref":"changelog.html#2-4-1-2020-09-12","title":"Changelog - 2.4.1 (2020-09-12)","type":"extras"},{"doc":"Fix StrayQuoteError not getting passed the correct arguments in strict mode. Fixes #96 . When headers are present multiple times and the :headers option is set to true , parse the values into a list. Contributed by @MrAlexLau in PR #97 .","ref":"changelog.html#2-4-0-2020-09-12","title":"Changelog - 2.4.0 (2020-09-12)","type":"extras"},{"doc":"Fix StrayQuoteError incorrectly getting raised when escape sequences end in new lines. Fixes #89 . Raised by @rockwood in Issue #96 .","ref":"changelog.html#2-3-1-2019-03-30","title":"Changelog - 2.3.1 (2019-03-30)","type":"extras"},{"doc":"Add StrayQuoteError which gets raised when a row has stray quotes rather than EscapeSequenceError to help with common encoding errors.","ref":"changelog.html#2-3-0-2019-03-17","title":"Changelog - 2.3.0 (2019-03-17)","type":"extras"},{"doc":"Make syntax compatible with latest Elixir releases Add validate_row_length: option defaulting to true to allow disabling validation of row length.","ref":"changelog.html#2-2-0-2019-03-03","title":"Changelog - 2.2.0 (2019-03-03)","type":"extras"},{"doc":"Make decode return row and error tuples instead of raising errors directly Make old behaviour of raising errors directly available via decode! Improve error messages for escape sequences Rewrite parts of the pipeline to be more modular","ref":"changelog.html#2-0-0-2017-05-29","title":"Changelog - 2.0.0 (2017-05-29)","type":"extras"},{"doc":"Load parallel_stream as an app dependency to avoid load level errors. See issue #56 reported by @luk3thomas","ref":"changelog.html#1-4-4-2016-11-12","title":"Changelog - 1.4.4 (2016-11-12)","type":"extras"},{"doc":"Fix a case where lines would not be aggregated correctly see #52 reported by @yury-dimov","ref":"changelog.html#1-4-3-2016-08-27","title":"Changelog - 1.4.3 (2016-08-27)","type":"extras"},{"doc":"Update dependency on parallel_stream","ref":"changelog.html#1-4-2-2016-06-20","title":"Changelog - 1.4.2 (2016-06-20)","type":"extras"},{"doc":"Fix condition where rows would be dropped when decoding from stateful streams. See #39 reported by @moxley","ref":"changelog.html#1-4-1-2016-05-21","title":"Changelog - 1.4.1 (2016-05-21)","type":"extras"},{"doc":"add option to specify headers in encode - added in #34 by @barruumrex","ref":"changelog.html#1-4-0-2016-04-03","title":"Changelog - 1.4.0 (2016-04-03)","type":"extras"},{"doc":"Fix empty streams raising a lexer error - raised in #28 by @kiliancs","ref":"changelog.html#1-3-3-2016-03-25","title":"Changelog - 1.3.3 (2016-03-25)","type":"extras"},{"doc":"Cleanup, removing some unused defaults in function headers to remove compile time warnings","ref":"changelog.html#1-3-2-2016-03-08","title":"Changelog - 1.3.2 (2016-03-08)","type":"extras"},{"doc":"Fix :strip_cells not stripping cells when multiple options are specified - #29 by @tomjoro","ref":"changelog.html#1-3-1-2016-03-08","title":"Changelog - 1.3.1 (2016-03-08)","type":"extras"},{"doc":"Now supports linebreaks inside escaped fields (#13) Raises an error when row length mismatches across rows Uses parallel_stream for parallelism","ref":"changelog.html#1-3-0-2016-03-01","title":"Changelog - 1.3.0 (2016-03-01)","type":"extras"},{"doc":"Fix encoding of double quotes","ref":"changelog.html#1-2-4-2016-02-06","title":"Changelog - 1.2.4 (2016-02-06)","type":"extras"},{"doc":"Fix a condition where headers: true would enumerate the whole file once before parsing","ref":"changelog.html#1-2-3-2016-01-19","title":"Changelog - 1.2.3 (2016-01-19)","type":"extras"},{"doc":"Fix default num_pipes argument to evaluate num_pipes dependent on scheduler at runtime Test utf-8 files with BOM Syntax and mix updates for elixir 1.2","ref":"changelog.html#1-2-2-2016-01-02","title":"Changelog - 1.2.2 (2016-01-02)","type":"extras"},{"doc":"Decoder performance optimisations","ref":"changelog.html#1-2-1-2015-10-17","title":"Changelog - 1.2.1 (2015-10-17)","type":"extras"},{"doc":"Use Stream.transform/4 - incompatible with Elixir &lt; 1.1.0","ref":"changelog.html#1-2-0-2015-10-11","title":"Changelog - 1.2.0 (2015-10-11)","type":"extras"},{"doc":"Decoder refactor from Stream.resource/3 to Stream.transform/3 in order to get more predictable stream behaviour Rows now get processed in order Fix a bug where stream would get evaluated before being decoded","ref":"changelog.html#1-1-5-2015-10-11","title":"Changelog - 1.1.5 (2015-10-11)","type":"extras"},{"doc":"Fix a bug where headers could be out of order","ref":"changelog.html#1-1-4-2015-09-13","title":"Changelog - 1.1.4 (2015-09-13)","type":"extras"},{"doc":"Fix a bug where headers could get parsed as the first row","ref":"changelog.html#1-1-3-2015-09-12","title":"Changelog - 1.1.3 (2015-09-12)","type":"extras"},{"doc":"Fix a bug where calls to decode with num_pipes: 1 would yield varying results due to leftover state in decoder message queue","ref":"changelog.html#1-1-2-2015-09-05","title":"Changelog - 1.1.2 (2015-09-05)","type":"extras"},{"doc":"Rescue from errors in stream producer to get more predictable behaviour in case of failure","ref":"changelog.html#1-1-1-2015-07-14","title":"Changelog - 1.1.1 (2015-07-14)","type":"extras"},{"doc":"Better error messages when encountering invalid encodings","ref":"changelog.html#1-1-0-2015-07-12","title":"Changelog - 1.1.0 (2015-07-12)","type":"extras"},{"doc":"Indicate consolidate_protocols for better encoding performance","ref":"changelog.html#1-0-1-2015-07-11","title":"Changelog - 1.0.1 (2015-07-11)","type":"extras"},{"doc":"Use bytes as separators","ref":"changelog.html#1-0-0-2015-05-24","title":"Changelog - 1.0.0 (2015-05-24)","type":"extras"},{"doc":"Add benchmarking","ref":"changelog.html#0-2-3-2015-05-24","title":"Changelog - 0.2.3 (2015-05-24)","type":"extras"},{"doc":"Use utf-8 bytes instead of codepoints for multi-byte parsing","ref":"changelog.html#0-2-2-2015-05-20","title":"Changelog - 0.2.2 (2015-05-20)","type":"extras"},{"doc":"Fix handling of multi-byte utf-8 characters","ref":"changelog.html#0-2-1-2015-05-20","title":"Changelog - 0.2.1 (2015-05-20)","type":"extras"},{"doc":"Implement encoder protocol","ref":"changelog.html#0-2-0-2015-03-25","title":"Changelog - 0.2.0 (2015-03-25)","type":"extras"},{"doc":"RFC 4180 compliant, composable CSV parsing and encoding for Elixir.","ref":"readme.html","title":"CSV","type":"extras"},{"doc":"Add { :csv , &quot;~&gt; 3.1&quot; } to your deps in mix.exs like so: defp deps do [ { :csv , &quot;~&gt; 3.1&quot; } ] end","ref":"readme.html#installation","title":"CSV - Installation","type":"extras"},{"doc":"CSV is a notoriously fickle format, with many implementations and files interpreting it differently. For that reason, CSV implements a normal mode CSV.decode that will return a stream of ok: [&quot;field1&quot;, &quot;field2&quot;] and err: &quot;Message&quot; tuples. It will also reparse lines after a previous line has opened an unterminated escape sequence , ensuring you get all correctly formatted rows. The goal of this library is to allow to extract all correctly formatted rows, while displaying descriptive errors for incorrectly formatted rows. In strict mode using CSV.decode! the library will raise an exception when it encounters the first error, aborting the operation.","ref":"readme.html#getting-all-correctly-formatted-rows","title":"CSV - Getting all correctly formatted rows","type":"extras"},{"doc":"This library uses fast binary matching and is able to parse about half a million rows of a moderately complex CSV file per second in a single process on a small cloud instance spec (2vCPU, 2GB Memory). CSV parsing will unlikely become a bottleneck in your data pipeline. If you are reading from a large file, CSV will perform best when streaming with :read_ahead in byte mode: File . stream! ( &quot;data.csv&quot; , [ read_ahead : 100_000 ] , 1000 ) |&gt; CSV . decode ( ) While 1000 is usually a good default number of bytes to stream, you should measure performance and fine-tune byte size according to your environment.","ref":"readme.html#performance","title":"CSV - Performance","type":"extras"},{"doc":"The main goal for 3.x has been to streamline the library API and leverage binary matching. Upgrading should require few to no changes in most cases Parallelism has been removed , alongside its options :num_workers and :worker_work_ratio . You can safely remove them. CSV now expects line breaks to be present in the data. If you used to parse strings by applying String.split/2 before passing it to decode, you can do the same now feeding in the string as a single item of a list: [ &quot;a,b,c \\n d,e,f&quot; ] |&gt; CSV . decode ( ) StrayQuoteError is now StrayEscapeCharacterError . If you catch this error in your code, you need to rename it. The :strip_fields option needs to be replaced with the :field_transform option: File . stream! ( &quot;data.csv&quot; ) |&gt; CSV . decode ( field_transform : &amp; String . trim / 1 ) :validate_row_length now defaults to false . This option produces an error for rows with different length. Set it to true to get the same behaviour as in 2.x :escape_formulas is now :unescape_formulas for decode and decode! . It is still :escape_formulas for encode . Change :escape_formulas to :unescape_formulas in decode calls to get the same behaviour as in 2.x :escape_max_lines now defaults to 10 instead of 1000 . To get the same behaviour as in 2.x, use: File . stream! ( &quot;data.csv&quot; ) |&gt; CSV . decode ( escape_max_lines : 1000 ) :replace has been removed . CSV will now return fields with incorrect encoding as-is. You can use the new :field_transform option to provide a function transforming fields while they are being parsed. This allows to e.g. replace incorrect encoding: defp replace_bad_encoding ( field ) do if String . valid? ( field ) do field else field |&gt; String . codepoints ( ) |&gt; Enum . map ( fn codepoint -&gt; if String . valid? ( codepoint ) , do : codepoint , else : &quot;?&quot; end ) |&gt; Enum . join ( ) end end File . stream! ( &quot;data.csv&quot; ) |&gt; CSV . decode ( field_transform : &amp; replace_bad_encoding / 1 ) That's it! Please open an issue if you see any other non-backward compatible behaviour so it can be documented. Elixir version requirements Elixir 1.5.0 is required for all versions above 2.5.0 . Elixir 1.1.0 is required for all versions above 1.1.5 .","ref":"readme.html#upgrading-from-2-x","title":"CSV - Upgrading from 2.x","type":"extras"},{"doc":"This library aims to to solve concerns related to csv parsing in data pipelines, following the UNIX philosophy: It consumes streams or enumerables, producing streams of lists, maps or tuples depending on configuration. This simplifies using it in data pipelines, where CSV encoding or decoding is only one of the processing steps.","ref":"readme.html#design-goals","title":"CSV - Design Goals","type":"extras"},{"doc":"CSV can decode and encode from and to a stream of bytes or lines. Decoding Do this to decode data: # Decode file line by line File . stream! ( &quot;data.csv&quot; ) |&gt; CSV . decode ( ) # Decode a UTF-16 file with BOM File . stream! ( [ :trim_bom , encoding : { :utf16 , :little } ] ) |&gt; CSV . decode ( ) # Decode file in chunks of 1000 bytes File . stream! ( &quot;data.csv&quot; , [ ] , 1000 ) |&gt; CSV . decode ( ) # Decode a csv formatted string [ &quot;long,csv,string \\\\ nwith,multiple,lines&quot; ] |&gt; CSV . decode ( ) # Decode a list of arbitrarily chunked csv data [ &quot;list,&quot; , &quot;of,arbitrarily&quot; , &quot; \\\\ nchun&quot; , &quot;ked,csv,data \\\\ n&quot; ] |&gt; CSV . decode ( ) And you'll get a stream of row tuples: [ ok : [ &quot;a&quot; , &quot;b&quot; ] , ok : [ &quot;c&quot; , &quot;d&quot; ] ] And, potentially error tuples: [ error : &quot;&quot; , ok : [ &quot;c&quot; , &quot;d&quot; ] ] Use strict mode decode! to get a two-dimensional list, raising errors as they occur, aborting the operation: File . stream! ( &quot;data.csv&quot; ) |&gt; CSV . decode! Redact data in exceptions that decode! throws to avoid potentially sensitive data showing up in logs: File . stream! ( &quot;data.csv&quot; ) |&gt; CSV . decode! ( redact_exception : true ) Options For all available options check the docs on decode and decode! Specify a semicolon separator: stream |&gt; CSV . decode ( separator : ?; ) Specify a custom escape character: stream |&gt; CSV . decode ( escape_character : ?@ ) Apply a transformation to a field when parsed, e.g. trimming the field: stream |&gt; CSV . decode ( field_transform : &amp; String . trim / 1 ) Unescape formulas that have been escaped: stream |&gt; CSV . decode ( unescape_formulas : true ) Encoding Do this to encode a table (two-dimensional list): table_data |&gt; CSV . encode And you'll get a stream of lines ready to be written to an IO. So, this is writing to a file: file = File . open! ( &quot;test.csv&quot; , [ :write , :utf8 ] ) table_data |&gt; CSV . encode |&gt; Enum . each ( &amp; IO . write ( file , &amp;1 ) ) Options Use a semicolon separator: your_data |&gt; CSV . encode ( separator : ?; ) Use a specific escape character: your_data |&gt; CSV . encode ( escape_character : ?@ ) You can also specify headers when encoding, which will encode map values into the right place: [ %{ &quot;a&quot; =&gt; &quot;value!&quot; } ] |&gt; CSV . encode ( headers : [ &quot;z&quot; , &quot;a&quot; ] ) # [&quot;z,a\\\\r\\\\n&quot;, &quot;,value!\\\\r\\\\n&quot;] You can also specify a keyword list, the keys of the list will be used as the keys for the rows, but the values will be the value used for the header row name in CSV output [ %{ a : &quot;value!&quot; } ] |&gt; CSV . encode ( headers : [ a : &quot;x&quot; , b : &quot;y&quot; ] ) # [&quot;x,y\\\\r\\\\n&quot;, &quot;value!,\\\\r\\\\n&quot;] You'll surely appreciate some more info on encode . Polymorphic encoding Make sure your data gets encoded the way you want - implement the CSV.Encode protocol for whatever you wish to encode: defimpl CSV.Encode , for : MyData do def encode ( % MyData { has : fun } , env \\\\ [ ] ) do &quot;so much \#{ fun } &quot; |&gt; CSV.Encode . encode ( env ) end end Or similar. Ensure performant encoding The encoding protocol implements a fallback to Any for types where a simple call o to_string will provide unambiguous results. Protocol dispatch for the fallback to Any is very slow when protocols are not consolidated, so make sure you have consolidate_protocols: true in your mix.exs or you consolidate protocols manually for production in order to get good performance. There is more to know about everything :tm: - Check the doc","ref":"readme.html#usage","title":"CSV - Usage","type":"extras"},{"doc":"Please make sure to add tests. I will not look at PRs that are either failing or lowering coverage. Also, solve one problem at a time.","ref":"readme.html#contributions-bugfixes-are-most-welcome","title":"CSV - Contributions &amp; Bugfixes are most welcome!","type":"extras"},{"doc":"Copyright (c) 2022 Beat Richartz CSV source code is licensed under the MIT License .","ref":"readme.html#copyright-and-license","title":"CSV - Copyright and License","type":"extras"}]